#include <glib-object.h>
#include <dbus/dbus-glib.h>
#include <telepathy-glib/dbus-properties-mixin.h>

G_BEGIN_DECLS

/**
 * SalutSvcConnectionInterfaceContactCapabilities:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SalutSvcConnectionInterfaceContactCapabilities SalutSvcConnectionInterfaceContactCapabilities;

/**
 * SalutSvcConnectionInterfaceContactCapabilitiesClass:
 *
 * The class of SalutSvcConnectionInterfaceContactCapabilities.
 */
typedef struct _SalutSvcConnectionInterfaceContactCapabilitiesClass SalutSvcConnectionInterfaceContactCapabilitiesClass;

GType salut_svc_connection_interface_contact_capabilities_get_type (void);
#define SALUT_TYPE_SVC_CONNECTION_INTERFACE_CONTACT_CAPABILITIES \
  (salut_svc_connection_interface_contact_capabilities_get_type ())
#define SALUT_SVC_CONNECTION_INTERFACE_CONTACT_CAPABILITIES(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SALUT_TYPE_SVC_CONNECTION_INTERFACE_CONTACT_CAPABILITIES, SalutSvcConnectionInterfaceContactCapabilities))
#define SALUT_IS_SVC_CONNECTION_INTERFACE_CONTACT_CAPABILITIES(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SALUT_TYPE_SVC_CONNECTION_INTERFACE_CONTACT_CAPABILITIES))
#define SALUT_SVC_CONNECTION_INTERFACE_CONTACT_CAPABILITIES_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SALUT_TYPE_SVC_CONNECTION_INTERFACE_CONTACT_CAPABILITIES, SalutSvcConnectionInterfaceContactCapabilitiesClass))


typedef void (*salut_svc_connection_interface_contact_capabilities_set_self_capabilities_impl) (SalutSvcConnectionInterfaceContactCapabilities *self,
    const GPtrArray *in_caps,
    DBusGMethodInvocation *context);
void salut_svc_connection_interface_contact_capabilities_implement_set_self_capabilities (SalutSvcConnectionInterfaceContactCapabilitiesClass *klass, salut_svc_connection_interface_contact_capabilities_set_self_capabilities_impl impl);
/**
 * salut_svc_connection_interface_contact_capabilities_return_from_set_self_capabilities:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_connection_interface_contact_capabilities_return_from_set_self_capabilities (DBusGMethodInvocation *context);
static inline void
salut_svc_connection_interface_contact_capabilities_return_from_set_self_capabilities (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_connection_interface_contact_capabilities_get_contact_capabilities_impl) (SalutSvcConnectionInterfaceContactCapabilities *self,
    const GArray *in_handles,
    DBusGMethodInvocation *context);
void salut_svc_connection_interface_contact_capabilities_implement_get_contact_capabilities (SalutSvcConnectionInterfaceContactCapabilitiesClass *klass, salut_svc_connection_interface_contact_capabilities_get_contact_capabilities_impl impl);
/**
 * salut_svc_connection_interface_contact_capabilities_return_from_get_contact_capabilities:
 * @context: The D-Bus method invocation context
 * @out0: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_connection_interface_contact_capabilities_return_from_get_contact_capabilities (DBusGMethodInvocation *context,
    GHashTable *out0);
static inline void
salut_svc_connection_interface_contact_capabilities_return_from_get_contact_capabilities (DBusGMethodInvocation *context,
    GHashTable *out0)
{
  dbus_g_method_return (context,
      out0);
}

void salut_svc_connection_interface_contact_capabilities_emit_contact_capabilities_changed (gpointer instance,
    GHashTable *arg_caps);

/**
 * SalutSvcOLPCActivityProperties:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SalutSvcOLPCActivityProperties SalutSvcOLPCActivityProperties;

/**
 * SalutSvcOLPCActivityPropertiesClass:
 *
 * The class of SalutSvcOLPCActivityProperties.
 */
typedef struct _SalutSvcOLPCActivityPropertiesClass SalutSvcOLPCActivityPropertiesClass;

GType salut_svc_olpc_activity_properties_get_type (void);
#define SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES \
  (salut_svc_olpc_activity_properties_get_type ())
#define SALUT_SVC_OLPC_ACTIVITY_PROPERTIES(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES, SalutSvcOLPCActivityProperties))
#define SALUT_IS_SVC_OLPC_ACTIVITY_PROPERTIES(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES))
#define SALUT_SVC_OLPC_ACTIVITY_PROPERTIES_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES, SalutSvcOLPCActivityPropertiesClass))


typedef void (*salut_svc_olpc_activity_properties_set_properties_impl) (SalutSvcOLPCActivityProperties *self,
    guint in_room,
    GHashTable *in_properties,
    DBusGMethodInvocation *context);
void salut_svc_olpc_activity_properties_implement_set_properties (SalutSvcOLPCActivityPropertiesClass *klass, salut_svc_olpc_activity_properties_set_properties_impl impl);
/**
 * salut_svc_olpc_activity_properties_return_from_set_properties:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_activity_properties_return_from_set_properties (DBusGMethodInvocation *context);
static inline void
salut_svc_olpc_activity_properties_return_from_set_properties (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_olpc_activity_properties_get_properties_impl) (SalutSvcOLPCActivityProperties *self,
    guint in_room,
    DBusGMethodInvocation *context);
void salut_svc_olpc_activity_properties_implement_get_properties (SalutSvcOLPCActivityPropertiesClass *klass, salut_svc_olpc_activity_properties_get_properties_impl impl);
/**
 * salut_svc_olpc_activity_properties_return_from_get_properties:
 * @context: The D-Bus method invocation context
 * @out_properties: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_activity_properties_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties);
static inline void
salut_svc_olpc_activity_properties_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties)
{
  dbus_g_method_return (context,
      out_properties);
}

typedef void (*salut_svc_olpc_activity_properties_get_activity_impl) (SalutSvcOLPCActivityProperties *self,
    const gchar *in_activity_id,
    DBusGMethodInvocation *context);
void salut_svc_olpc_activity_properties_implement_get_activity (SalutSvcOLPCActivityPropertiesClass *klass, salut_svc_olpc_activity_properties_get_activity_impl impl);
/**
 * salut_svc_olpc_activity_properties_return_from_get_activity:
 * @context: The D-Bus method invocation context
 * @out_room: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_activity_properties_return_from_get_activity (DBusGMethodInvocation *context,
    guint out_room);
static inline void
salut_svc_olpc_activity_properties_return_from_get_activity (DBusGMethodInvocation *context,
    guint out_room)
{
  dbus_g_method_return (context,
      out_room);
}

void salut_svc_olpc_activity_properties_emit_activity_properties_changed (gpointer instance,
    guint arg_room,
    GHashTable *arg_properties);

/**
 * SalutSvcOLPCBuddyInfo:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SalutSvcOLPCBuddyInfo SalutSvcOLPCBuddyInfo;

/**
 * SalutSvcOLPCBuddyInfoClass:
 *
 * The class of SalutSvcOLPCBuddyInfo.
 */
typedef struct _SalutSvcOLPCBuddyInfoClass SalutSvcOLPCBuddyInfoClass;

GType salut_svc_olpc_buddy_info_get_type (void);
#define SALUT_TYPE_SVC_OLPC_BUDDY_INFO \
  (salut_svc_olpc_buddy_info_get_type ())
#define SALUT_SVC_OLPC_BUDDY_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SALUT_TYPE_SVC_OLPC_BUDDY_INFO, SalutSvcOLPCBuddyInfo))
#define SALUT_IS_SVC_OLPC_BUDDY_INFO(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SALUT_TYPE_SVC_OLPC_BUDDY_INFO))
#define SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SALUT_TYPE_SVC_OLPC_BUDDY_INFO, SalutSvcOLPCBuddyInfoClass))


typedef void (*salut_svc_olpc_buddy_info_set_properties_impl) (SalutSvcOLPCBuddyInfo *self,
    GHashTable *in_properties,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_set_properties (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_properties_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_set_properties:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_set_properties (DBusGMethodInvocation *context);
static inline void
salut_svc_olpc_buddy_info_return_from_set_properties (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_olpc_buddy_info_get_properties_impl) (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_get_properties (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_properties_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_get_properties:
 * @context: The D-Bus method invocation context
 * @out_properties: GHashTable * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties);
static inline void
salut_svc_olpc_buddy_info_return_from_get_properties (DBusGMethodInvocation *context,
    GHashTable *out_properties)
{
  dbus_g_method_return (context,
      out_properties);
}

typedef void (*salut_svc_olpc_buddy_info_set_activities_impl) (SalutSvcOLPCBuddyInfo *self,
    const GPtrArray *in_activities,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_set_activities (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_activities_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_set_activities:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_set_activities (DBusGMethodInvocation *context);
static inline void
salut_svc_olpc_buddy_info_return_from_set_activities (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_olpc_buddy_info_add_activity_impl) (SalutSvcOLPCBuddyInfo *self,
    const gchar *in_id,
    guint in_handle,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_add_activity (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_add_activity_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_add_activity:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_add_activity (DBusGMethodInvocation *context);
static inline void
salut_svc_olpc_buddy_info_return_from_add_activity (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_olpc_buddy_info_get_activities_impl) (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_get_activities (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_activities_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_get_activities:
 * @context: The D-Bus method invocation context
 * @out_activities: const GPtrArray * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_get_activities (DBusGMethodInvocation *context,
    const GPtrArray *out_activities);
static inline void
salut_svc_olpc_buddy_info_return_from_get_activities (DBusGMethodInvocation *context,
    const GPtrArray *out_activities)
{
  dbus_g_method_return (context,
      out_activities);
}

typedef void (*salut_svc_olpc_buddy_info_set_current_activity_impl) (SalutSvcOLPCBuddyInfo *self,
    const gchar *in_activity,
    guint in_channel,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_set_current_activity (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_current_activity_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_set_current_activity:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_set_current_activity (DBusGMethodInvocation *context);
static inline void
salut_svc_olpc_buddy_info_return_from_set_current_activity (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

typedef void (*salut_svc_olpc_buddy_info_get_current_activity_impl) (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context);
void salut_svc_olpc_buddy_info_implement_get_current_activity (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_current_activity_impl impl);
/**
 * salut_svc_olpc_buddy_info_return_from_get_current_activity:
 * @context: The D-Bus method invocation context
 * @out_activity: const gchar * (FIXME, generate documentation)
 * @out_channel: guint  (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void salut_svc_olpc_buddy_info_return_from_get_current_activity (DBusGMethodInvocation *context,
    const gchar *out_activity,
    guint out_channel);
static inline void
salut_svc_olpc_buddy_info_return_from_get_current_activity (DBusGMethodInvocation *context,
    const gchar *out_activity,
    guint out_channel)
{
  dbus_g_method_return (context,
      out_activity,
      out_channel);
}

void salut_svc_olpc_buddy_info_emit_properties_changed (gpointer instance,
    guint arg_contact,
    GHashTable *arg_properties);
void salut_svc_olpc_buddy_info_emit_activities_changed (gpointer instance,
    guint arg_contact,
    const GPtrArray *arg_activities);
void salut_svc_olpc_buddy_info_emit_current_activity_changed (gpointer instance,
    guint arg_contact,
    const gchar *arg_activity,
    guint arg_channel);


G_END_DECLS
